unit Main;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls, StdActns,
  ActnList, ToolWin, ImgList, abActnLst, abSecurity, Db, DBTables;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileCloseItem: TMenuItem;
    Window1: TMenuItem;
    Help1: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    OpenDialog: TOpenDialog;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    Edit1: TMenuItem;
    CutItem: TMenuItem;
    CopyItem: TMenuItem;
    PasteItem: TMenuItem;
    WindowMinimizeItem: TMenuItem;
    StatusBar: TStatusBar;
    ActionList1: TabActionList;
    EditCut1: TabAction;
    EditCopy1: TabAction;
    EditPaste1: TabAction;
    FileNew1: TabAction;
    FileSave1: TabAction;
    FileExit1: TabAction;
    FileOpen1: TabAction;
    FileSaveAs1: TabAction;
    WindowCascade1: TabAction;
    WindowTileHorizontal1: TabAction;
    WindowArrangeAll1: TabAction;
    WindowMinimizeAll1: TabAction;
    HelpAbout1: TabAction;
    FileClose1: TabAction;
    WindowTileVertical1: TabAction;
    WindowTileItem2: TMenuItem;
    ToolBar2: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton9: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ImageList1: TImageList;
    BitBtn1: TBitBtn;
    abactCheckRights: TabAction;
    Button1: TButton;
    BitBtn2: TBitBtn;
    abactChangeLogon: TabAction;
    btnSaveToStreamDemo: TButton;
    Memo1: TMemo;
    Label1: TLabel;
    abSecurity1: TabSecurity;
    abAutoGenerated: TabAction;
    Label2: TLabel;
    Label3: TLabel;
    dbConnectTest: TDatabase;
    tblSecurity: TTable;
    tblSecurityid: TIntegerField;
    tblSecuritydata: TBlobField;
    procedure FileNew1Execute(Sender: TObject);
    procedure FileOpen1Execute(Sender: TObject);
    procedure HelpAbout1Execute(Sender: TObject);
    procedure FileExit1Execute(Sender: TObject);
    procedure abactCheckRightsExecute(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FileClose1Execute(Sender: TObject);
    procedure abactChangeLogonExecute(Sender: TObject);
    procedure btnSaveToStreamDemoClick(Sender: TObject);
    procedure Label3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure abSecurity1Logon(var Accept: Boolean; const sUserName,
      sPassword: String; lstParameters: TStrings;
      var sErrorMessage: String);
    procedure abSecurity1WriteSecurityTemplate(
      var SkipFurtherWriting: Boolean; strUserTemplate: TMemoryStream);
    procedure abSecurity1ReadSecurityTemplate(var Done,
      ShowLogonAgain: Boolean; strUserTemplate: TMemoryStream;
      const sUserName, sPassword: String; lstParameters: TStrings;
      var sMessage: String);
    procedure abSecurity1BeforeChangePassword(var Accept: Boolean;
      const sUserName, sPassword: String);
  private
    { Private declarations }
    procedure CreateMDIChild(const Name: string);
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses ChildWin, About;

procedure TMainForm.CreateMDIChild(const Name: string);
var
  Child: TMDIChild;
begin
  { create a new MDI child window }
  Child := TMDIChild.Create(Application);
  Child.Caption := Name;
  if FileExists(Name) then Child.Memo1.Lines.LoadFromFile(Name);
end;

procedure TMainForm.FileNew1Execute(Sender: TObject);
begin
  CreateMDIChild('NONAME' + IntToStr(MDIChildCount + 1));
end;

procedure TMainForm.FileOpen1Execute(Sender: TObject);
begin
  if OpenDialog.Execute then
    CreateMDIChild(OpenDialog.FileName);
end;

procedure TMainForm.HelpAbout1Execute(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TMainForm.FileExit1Execute(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.abactCheckRightsExecute(Sender: TObject);
begin
  abSecurity1.ShowPrivileges;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  if abSecurity1.CheckId(32) then
    ShowMessage('ID 32 Enabled')
  else
    ShowMessage('ID 32 Disabled');
end;

procedure TMainForm.FileClose1Execute(Sender: TObject);
begin
  if Assigned(ActiveMDIChild) then
    ActiveMDIChild.Close;
end;

procedure TMainForm.abactChangeLogonExecute(Sender: TObject);
begin
  abSecurity1.Logon;
end;

procedure TMainForm.btnSaveToStreamDemoClick(Sender: TObject);
var
  strUserTemplate: TMemoryStream;
begin
  strUserTemplate := TMemoryStream.Create;
  try
    abSecurity1.UserTemplate.SaveToStreamSecurity(strUserTemplate);
    ShowMessage('User Template serialized into a memory Stream. Stream Size is: ' +
                intToStr(strUserTemplate.Size) + ' bytes.')
  finally
    strUserTemplate.Destroy;
  end;
end;

procedure TMainForm.Label3Click(Sender: TObject);
begin
  //
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
  //
end;


procedure TMainForm.abSecurity1Logon(var Accept: Boolean; const sUserName, sPassword: String; lstParameters: TStrings; var sErrorMessage: String);
begin
  dbConnectTest.Connected := false;
  dbConnectTest.LoginPrompt := false;
  dbConnectTest.Params.Clear;
  dbConnectTest.Params.Values['PATH'] := lstParameters.Values['PATH'];
  //non meaningful for Paradox DB
  //dbConnectTest.Params.Values['USER NAME'] := sUserName;
  //dbConnectTest.Params.Values['PASSWORD'] := sPassword;
  tblSecurity.TableName := lstParameters.Values['TableName'];
  try
    dbConnectTest.Connected := true;
    Accept := true;
  except
    on E:Exception do
    begin
      sErrorMessage := E.Message;
      Accept := false;
    end;
  end;
end;

procedure TMainForm.abSecurity1WriteSecurityTemplate(var SkipFurtherWriting: Boolean; strUserTemplate: TMemoryStream);
begin
  tblSecurity.Open;
  if tblSecurity.bof and tblSecurity.eof then
  begin
    tblSecurity.Insert;
    tblSecurityid.AsInteger := 1;
  end
  else
  begin
    tblSecurity.First;
    tblSecurity.Edit;
  end;
  tblSecuritydata.LoadFromStream(strUserTemplate);
  tblSecurity.Post;
  SkipFurtherWriting := true;
end;

procedure TMainForm.abSecurity1ReadSecurityTemplate(var Done, ShowLogonAgain: Boolean; strUserTemplate: TMemoryStream; const sUserName, sPassword: String; lstParameters: TStrings; var sMessage: String);
var
  bPasswordOK: boolean;
begin
  //Typically you should write code for onReadSecurityTemplate, onWriteSecurityTemplate, onLogon and onBeforeChangePassword events
  //when delivering to client you should remove soCreateSupervisorIfMissing from abSecurity.Options
  // (use this option in house to generate an initial security template to be delivered to the client later on - as file or to populate a blob field in its database)
  //You may chose to use the database password authentication only (not to store nor check any password within Security Builder)
  // If so, set soExternalPasswordAutentication in abSecurity.Options. If this option is set (default) Security Builder will
  // perform its own password check. In order to dissable changing password in Security Builder you should write an onBeforeChangePassword event handler and set Accept to false
  //Note: the code is long to illustrate multiple possible scenarios. In real life you don't need to write so much code...
  dbConnectTest.Connected := false;
  if not dbConnectTest.Connected then
  begin
    dbConnectTest.LoginPrompt := false;
    dbConnectTest.Params.Clear;
    dbConnectTest.Params.Values['PATH'] := lstParameters.Values['PATH'];
    //non meaningful for Paradox DB
    //dbConnectTest.Params.Values['USER NAME'] := sUserName;
    //dbConnectTest.Params.Values['PASSWORD'] := sPassword;
    tblSecurity.TableName := lstParameters.Values['TableName'];
    try
      dbConnectTest.Connected := true;
    except
        ShowLogonAgain := true;
        sMessage := 'Incorrect user/password supplied. Cannot log on to the database';
        exit;
    end;
  end;

  try
    tblSecurity.Open;
  except
    ShowLogonAgain := true;
    sMessage := 'Cannot access security template: table may not exist or user may have unsufficient rights';
    exit;
  end;
  if tblSecurity.bof and tblSecurity.eof then//return the default Done = ShowLogonAgain = false
    Done := true
  else if tblSecuritydata.IsNull then
    begin
      strUserTemplate.Clear;
      Done := true;
      sMessage := 'Warning: Security model is empty. You should either enter "Security" as Supervisor (no password) and add the user (do not forget to set user password equal to current one) or contact your administrator.';
    end
    else
    begin
      tblSecuritydata.SaveToStream(strUserTemplate);
      Done := true;
      if TabSecurity.UserExistInTemplateStream(strUserTemplate, sUserName, sPassword, bPasswordOK) then
      begin
        if bPasswordOK then
          sMessage := 'Successfuly logged to the database.'
        else
          sMessage := 'Warning: Password in security model differs from the one supplied.'
      end
      else
        sMessage := 'Warning: User does not exist in security model. You should either enter "Security" as Supervisor/no password and add the user (do not forget to set user password equal to current one) or contact your administrator.';
    end;
end;

procedure TMainForm.abSecurity1BeforeChangePassword(var Accept: Boolean; const sUserName, sPassword: String);
begin
  //Accept := false;
end;

end.
