unit JPMGraphics;

interface

{$I JPM.INC}

uses Graphics;

//: This returns the Font for Icon lables in the Font specified by AFont
procedure GetIconFont (AFont: TFont);
//: This returns the Font for message text in the Font specified by AFont
procedure GetMessageFont (AFont: TFont);
//: This returns the Font for menu text in the Font specified by AFont
procedure GetMenuFont (AFont: TFont);
//: This returns the Font for window captions in the Font specified by AFont
procedure GetCaptionFont (AFont: TFont);
//: This returns the Font for status bars in the Font specified by AFont
procedure GetStatusFont (AFont: TFont);

implementation
uses JPMutils, Windows;

{These are internal methods and should never be called outside the unit because
 a TFont is created in them and something such as
 Form1.MyFont := InternalGetMessageFont would cause a memory leak}

function InternalGetIconFont: TFont;
begin
     Result := TFont.Create;
     Result.Handle := CreateFontIndirect (GettagICONMETRICS.lfFont);
end;

function InternalGetMessageFont: TFont;
begin
     Result := TFont.Create;
     Result.Handle := CreateFontIndirect (GetTNonClientMetrics.lfMessageFont);
end;

function InternalGetMenuFont: TFont;
begin
     Result := TFont.Create;
     Result.Handle := CreateFontIndirect (GetTNonClientMetrics.lfMenuFont);
end;

function InternalGetCaptionFont: TFont;
begin
     Result := TFont.Create;
     Result.Handle := CreateFontIndirect (GetTNonClientMetrics.lfCaptionFont);
end;

function InternalGetStatusFont: TFont;
begin
     Result := TFont.Create;
     Result.Handle := CreateFontIndirect (GetTNonClientMetrics.lfStatusFont);
end;

{These are public Font routines}

procedure GetIconFont (AFont: TFont);
var
     f: TFont;
begin
     f := InternalGetIconFont;
     try
          AFont.Assign (f);
     finally
          f.Free;
     end;
end;

procedure GetMessageFont (AFont: TFont);
var
     f: TFont;
begin
     f := InternalGetMessageFont;
     try
          AFont.Assign (f);
     finally
          f.Free;
     end;
end;

procedure GetMenuFont (AFont: TFont);
var
     f: TFont;
begin
     f := InternalGetMenuFont;
     try
          AFont.Assign (f);
     finally
          f.Free;
     end;
end;

procedure GetCaptionFont (AFont: TFont);
var
     f: TFont;
begin
     f := InternalGetCaptionFont;
     try
          AFont.Assign (f);
     finally
          f.Free;
     end;
end;

procedure GetStatusFont (AFont: TFont);
var
     f: TFont;
begin
     f := InternalGetStatusFont;
     try
          AFont.Assign (f);
     finally
          f.Free;
     end;
end;

end.
