unit JPMWinApiEx;

interface
uses Windows;

const

     //: flag in bwSuiteMask - Microsoft BackOffice components are installed.
     VER_SUITE_BACKOFFICE = $00000004;
     //: flag in bwSuiteMask - Windows 2000 DataCenter Server is installed.
     VER_SUITE_DATACENTER = $00000080;
     //: flag in bwSuiteMask - Windows 2000 Advanced Server is installed.
     VER_SUITE_ENTERPRISE = $00000002;
     //: flag in bwSuiteMask - Microsoft Small Business Server is installed.
     VER_SUITE_SMALLBUSINESS = $00000001;
     //: flag in bwSuiteMask - Microsoft Small Business Server is installed with the Restrictive Client license in force.
     VER_SUITE_SMALLBUSINESS_RESTRICTED = $00000020;
     //: flag in bwSuiteMask - Terminal Services is installed.
     VER_SUITE_TERMINAL = $00000010;

     //: constant for bwProductType - Windows 2000 Professional
     VER_NT_WORKSTATION = $0000001;
     //: constant for bwProductType - Windows 2000 domain controller
     VER_NT_DOMAIN_ContROLLER = $0000002;
     //: constant for bwProductType - Windows 2000 Server
     VER_NT_SERVER = $0000003;

     //: This extended version information.  Because Borland did not define it, we do so here.  This is because Win2000 extended it.
type
     TOSVersionInfoEx2 = record
          //: This is the size of structure which we pass to Windows
          dwOSVersionInfoSize: UInt;
          //: This is the Major version
          dwMajorVersion: UInt;
          //: This is the Minor Operating System version
          dwMinorVersion: UInt;
          //: This is the build number for the Operating System
          dwBuildNumber: UInt;
          //: This is the platform ID value
          dwPlatformId: UInt;
          //: This contains additional information.  On Windows NT 4.0, it will include the Service pack installed
          szCSDVersion: array [0..127] of AnsiChar; { Maintenance string for PSS usage }
          //: Windows 2000 only - Identifies the major version number of the latest Service Pack installed on the system. For example, for Service Pack 3, the major version number is 3. If no Service Pack has been installed, the value is zero.
          wServicePackMajor: Word;
          //: Windows 2000 only - Identifies the minor version number of the latest Service Pack installed on the system. For example, for Service Pack 3, the minor version number is 0.
          wServicePackMinor: Word;
          //: Windows 2000 only - A set of bit flags that identify the product suites available on the system.
          wSuiteMask: Word;
          //: Windows 2000 only - This indicates product type
          bwProductType: Byte;
          //: Windows 2000 only - This is for future use
          bwReserved: Byte;
     end;

     //: This is an extended version of the GetVersionEx function for the Windows 2000 Excention
function GetVersionEx2 (var lpVersionInformationEx: TOSVersionInfoEx2): BOOL; stdcall;

implementation

function GetVersionEx2; external kernel32 name 'GetVersionExA';

end.
