unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, sPanel, StdCtrls, Mask, sCustomComboEdit, sTooledit,
  sCustomComboBox, ActnList, sButtonControl, sCustomButton, sCustomListBox,
  sSkinManager, sMemo, sCustomLabel, sCurrEdit, sCurrencyEdit, sEdit,
  sSpinEdit, inifiles, sRadioButton, sCheckedControl, sCheckbox, sComboEdit,
  sBevel, Menus, ExtDlgs, sTrackBar, sPageControl, ComCtrls, sHintManager,
  sSkinProvider, sScrollBar, ImgList;

type
  TForm1 = class(TForm)
    ActionList1: TActionList;
    ActionNewSkin: TAction;
    ActionDeleteSkin: TAction;
    ActionSynonym: TAction;
    ActionCloneSection: TAction;
    ActionDeleteSection: TAction;
    OpenDialog1: TOpenDialog;
    ActionRefresh: TAction;
    ActionViewAll: TAction;
    ActionGlass: TAction;
    PopupMenu1: TPopupMenu;
    Clone1: TMenuItem;
    Synonym1: TMenuItem;
    OpenPictureDialog1: TOpenPictureDialog;
    ActionCreateSection: TAction;
    ActionExit: TAction;
    sSkinManager1: TsSkinManager;
    sHintManager1: TsHintManager;
    ActionRenameSection: TAction;
    sSkinProvider1: TsSkinProvider;
    sDirectoryEdit1: TsDirectoryEdit;
    sComboBox1: TsComboBox;
    sBitBtn1: TsBitBtn;
    sBitBtn2: TsBitBtn;
    sBitBtn3: TsBitBtn;
    sBitBtn4: TsBitBtn;
    sBitBtn6: TsBitBtn;
    sListBox2: TsListBox;
    sMemo1: TsMemo;
    sPanel1: TsPanel;
    sSpeedButton3: TsSpeedButton;
    sSpeedButton4: TsSpeedButton;
    sSpeedButton5: TsSpeedButton;
    sBitBtn5: TsBitBtn;
    sEdit1: TsEdit;
    sEdit2: TsEdit;
    sSpeedButton1: TsSpeedButton;
    ActionPropEdit: TAction;
    ImageList: TImageList;
    procedure FormShow(Sender: TObject);
    procedure sComboBox1Change(Sender: TObject);
    procedure ActionNewSkinExecute(Sender: TObject);
    procedure ActionDeleteSkinExecute(Sender: TObject);
    procedure ActionSynonymExecute(Sender: TObject);
    procedure ActionCloneSectionExecute(Sender: TObject);
    procedure ActionDeleteSectionExecute(Sender: TObject);
    procedure sListBox2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ActionRefreshExecute(Sender: TObject);
    procedure ActionViewAllExecute(Sender: TObject);
    procedure sMemo1VScroll(Sender: TObject);
    procedure sMemo1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure sMemo1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure sMemo1Change(Sender: TObject);
    procedure ActionCreateSectionExecute(Sender: TObject);
    procedure ActionExitExecute(Sender: TObject);
    procedure ActionRenameSectionExecute(Sender: TObject);
    procedure ActionPropEditExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure GetDefaultSections(List : TStrings);
    procedure GetAssignedSections(List : TStrings);
    procedure CreateEditor;
    procedure RealignControl;
    procedure PropertyChange(Sender: TObject);
    procedure EditButtonClick(Sender: TObject);
    procedure UpdateEditor;
    procedure RemoveEditors;
  end;

  function SubInStr(Str, Sub : string; const WordDelims: TSysCharSet) : boolean;


const
  Delim = [' ', '=', #13, #10];
var
  Form1 : TForm1;
  SkinPath : string;

  SkinChanged : boolean = False;
  CurrentLine : integer = -1;
  CurrentProp : string;
  CurrentClass : string;
  CurrentSection : string;
  CurrentSectionIndex : integer = -1;

  DataFile : TIniFile;
  MemData : TIniFile;

  PropEditors : TMemIniFile;

  Editor : TWinControl;

  sCheckControl : TsCheckBox;
  sColorControl : TsColorSelect;
  sPercentControl : TsSpinEdit;
  sGradControl : TsSpeedButton;
  sImgControl : TsSpeedButton;

implementation

uses sUtils, sStoreUtils, Unit2, sStyleSimply, sMessages, sConst, sGradBuilder,
  sGradient, UnitPropEdit;

{$R *.DFM}

function SubInStr(Str, Sub : string; const WordDelims: TSysCharSet) : boolean;
var
  i, c : integer;
begin
  Result := False;
  c := WordCount(Str, Delim);
  for i := 1 to c do begin
    if UpperCase(Sub) = UpperCase(ExtractWord(i, Str, Delim)) then begin
      Result := True;
      break;
    end;
  end;      
end;

procedure TForm1.FormShow(Sender: TObject);
var
  FileInfo: TSearchRec;
  DosCode: Integer;
  s : string;
begin
  sSkinManager1.SkinDirectory := sDirectoryEdit1.Text;
  SkinPath := sSkinManager1.GetFullskinDirectory;
  sComboBox1.Items.Clear;

  if DirExists(SkinPath) then begin
    s := SkinPath + '\*.*';

    DosCode := FindFirst(s, faDirectory, FileInfo);
    try
      while DosCode = 0 do begin
        if (FileInfo.Name[1] <> '.') and (FileInfo.Attr and faDirectory = faDirectory) then begin
          sComboBox1.Items.Add(FileInfo.Name);
        end;
        DosCode := FindNext(FileInfo);
      end;
    finally
      FindClose(FileInfo);
    end;
  end;
  sComboBox1.ItemIndex := sComboBox1.IndexOfKod(sSkinManager1.SkinName);
  GetAssignedSections(sListBox2.Items);
  if sListBox2.Items.Count > 0 then begin
    sListBox2.Enabled := True;
    sListBox2.ItemIndex := 0;
    sListBox2.OnClick(sListBox2);
  end;

  s := GetAppPath + 'PropEditors.ini';
  PropEditors := TMemIniFile.Create(s);
end;

procedure TForm1.sComboBox1Change(Sender: TObject);
var
  s : string;
  i : integer;
begin
  if (sListBox2.ItemIndex > -1) then begin
    s := sListBox2.Items[sListBox2.ItemIndex];
  end;
  sSkinManager1.SkinName := sComboBox1.Text;
  GetAssignedSections(sListBox2.Items);

  sListBox2.Enabled := True;
  ActionCloneSection.Enabled := True;
  ActionDeleteSection.Enabled := True;
  ActionSynonym.Enabled := True;

  sMemo1.Clear;
  sListBox2.Items.BeginUpdate;
  for i := 0 to sListBox2.Items.Count - 1 do if sListBox2.Items[i] = s then begin
    sListBox2.ItemIndex := i;
    sListBox2.OnClick(sListBox2);
  end;
  ActionRenameSection.Enabled := sListBox2.ItemIndex > -1; 
  sListBox2.Items.EndUpdate;
end;

procedure TForm1.ActionNewSkinExecute(Sender: TObject);
begin
//
end;

procedure TForm1.ActionDeleteSkinExecute(Sender: TObject);
begin
//
end;

procedure TForm1.ActionSynonymExecute(Sender: TObject);
begin
//
end;

procedure TForm1.ActionCloneSectionExecute(Sender: TObject);
begin
//
end;

procedure TForm1.ActionDeleteSectionExecute(Sender: TObject);
begin
  if CustomRequest('Do you really want to delete section <' + sListBox2.Items[sListBox2.ItemIndex] + '> ?') then begin
    sSkinData.SkinFile.EraseSection(sListBox2.Items[sListBox2.ItemIndex]);
    sListBox2.Items.Delete(sListBox2.ItemIndex);
    sMemo1.Clear;
  end;
end;

procedure TForm1.GetDefaultSections(List: TStrings);
begin

end;

procedure TForm1.GetAssignedSections(List: TStrings);
//var
//  i : integer;
begin
  if not Assigned(sSkinData.SkinFile) then Exit;
  List.BeginUpdate;
  List.Clear;
  sSkinData.SkinFile.ReadSections(List);
  List.EndUpdate;
end;

procedure TForm1.sListBox2Click(Sender: TObject);
var
  i : integer;
begin
  if not Assigned(sSkinData.SkinFile) then Exit;
  sMemo1.Lines.BeginUpdate;

  i := sListBox2.ItemIndex;
  sListBox2.Items.BeginUpdate;
  if ActionRefresh.Enabled then ActionRefresh.Execute;
  sListBox2.ItemIndex := i;
  sListBox2.Items.EndUpdate;

  sMemo1.Clear;
  sSkinData.SkinFile.ReadSection(sListBox2.Items[sListBox2.ItemIndex], sMemo1.Lines);
  for i := 0 to sMemo1.Lines.Count - 1 do begin
    sMemo1.Lines[i] := sMemo1.Lines[i] + ' = ' +
          ReadIniString(sListBox2.Items[sListBox2.ItemIndex], sMemo1.Lines[i], sSkinData.SkinFile);
  end;
  sMemo1.Lines.EndUpdate;

  sMemo1.Enabled := True;

  ActionRenameSection.Enabled := sListBox2.ItemIndex > -1;

  RemoveEditors;
  CurrentSectionIndex := sListBox2.ItemIndex;
  ActionRefresh.Enabled := False;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//  FreeAndNil(DataFile);
  PropEditors.UpdateFile;
  FreeAndNil(PropEditors);
end;

procedure TForm1.ActionRefreshExecute(Sender: TObject);
var
  i : integer;
  sl : TStringList;
begin
  if CurrentSectionIndex < 0 then Exit;
  sl := TStringList.Create;
  sl.Assign(sMemo1.Lines);
  sl.Sort;
  sSkinData.SkinFile.EraseSection(sListBox2.Items[CurrentSectionIndex]);

  for i := 0 to sl.Count - 1 do begin
    sSkinData.SkinFile.WriteString(sListBox2.Items[CurrentSectionIndex], ExtractWord(1, sl[i], Delim),  ExtractWord(2, sl[i], Delim));
  end;
  sSkinData.SkinFile.UpdateFile;
  FreeAndNil(sl);
  sSkinManager1.SkinName := sSkinManager1.SkinName;
  SkinChanged := False;
  ActionRefresh.Enabled := False;
end;

procedure TForm1.ActionViewAllExecute(Sender: TObject);
begin
  Application.CreateForm(TForm2, Form2);
  Form2.Show;
end;

procedure TForm1.CreateEditor;
const
  EditWidth = 54;
var
  cname, pname : string;
  function GetClassName : string; begin
    Result := sSkinData.SkinFile.ReadString(sListBox2.Items[sListBox2.ItemIndex], 'ClassName', '');
    if Result = '' then begin
      Result := sListBox2.Items[sListBox2.ItemIndex];
    end;
  end;
  function GetPropName : string; begin
    Result := ExtractWord(1, sMemo1.Lines[sMemo1.CaretPos.y], Delim);
  end;
begin
  RemoveEditors;
  if sListBox2.ItemIndex < 0 then Exit;
  CurrentSection := sListBox2.Items[sListBox2.ItemIndex];
  CurrentProp := GetPropName;
  cname := GetClassName;
  pname := GetPropName;
  // EditBool
  if SubInStr(ReadIniString('Main', 'Boolean', PropEditors), pname, Delim) then begin
    sCheckControl := TsCheckBox.Create(sPanel1);
    Editor := sCheckControl;
    sCheckControl.Left := 2;
    sCheckControl.Top := (sMemo1.CaretPos.y - sMemo1.FirstLineIndex) * (abs(sMemo1.Font.Height) + 2) + 1;
    sCheckControl.Width := EditWidth;
    sCheckControl.Parent := sPanel1;
    sCheckControl.Checked := False;
    sCheckControl.Checked := sSkinData.SkinFile.ReadString(CurrentSection, CurrentProp, 'False') <> 'False';
    sCheckControl.Visible := True;
    sCheckControl.Caption := '';
    sCheckControl.OnChange := PropertyChange;
  end
  // Color
  else if SubInStr(ReadIniString('Main', 'Color', PropEditors), pname, Delim) then begin
    sColorControl := TsColorSelect.Create(sPanel1);
    Editor := sColorControl;
    sColorControl.Left := 2;
    sColorControl.Top := (sMemo1.CaretPos.y - sMemo1.FirstLineIndex) * (abs(sMemo1.Font.Height) + 2) + 1;
    sColorControl.Width := EditWidth;
    sColorControl.Parent := sPanel1;
    sColorControl.Spacing := 0;
    sColorControl.ImgWidth := 38;
    sColorControl.Visible := True;
    sColorControl.Caption := '';
    sColorControl.OnChange := PropertyChange;
    sColorControl.ColorValue := sSkinData.SkinFile.ReadInteger(CurrentSection, CurrentProp, 0);
  end
  // Percent
  else if SubInStr(ReadIniString('Main', 'Percent', PropEditors), pname, Delim) then begin
    sPercentControl := TsSpinEdit.Create(sPanel1);
    Editor := sPercentControl;
    sPercentControl.Left := 2;
    sPercentControl.Top := (sMemo1.CaretPos.y - sMemo1.FirstLineIndex) * (abs(sMemo1.Font.Height) + 2) + 1;
    sPercentControl.Width := EditWidth;
    sPercentControl.Parent := sPanel1;
    sPercentControl.Visible := True;
    sPercentControl.OnChange := PropertyChange;
    sPercentControl.MaxValue := 100;
    sPercentControl.Value := sSkinData.SkinFile.ReadInteger(CurrentSection, CurrentProp, 0);
  end
  // Gradient
  else if SubInStr(ReadIniString('Main', 'Gradient', PropEditors), pname, Delim) then begin
    sGradControl := TsSpeedButton.Create(sPanel1);
    Editor := sGradControl;
    sGradControl.Left := 2;
    sGradControl.Top := (sMemo1.CaretPos.y - sMemo1.FirstLineIndex) * (abs(sMemo1.Font.Height) + 2) + 1;
    sGradControl.Width := EditWidth;
    sGradControl.Height := 16;
    sGradControl.Caption := '. . .';
    sGradControl.Parent := sPanel1;
    sGradControl.Visible := True;
    sGradControl.OnClick := EditButtonClick;
  end
  // Bitmap
  else if SubInStr(ReadIniString('Main', 'Bitmap', PropEditors), pname, Delim) then begin
    sImgControl := TsSpeedButton.Create(sPanel1);
    Editor := sImgControl;
    sImgControl.Tag := 0;
    sImgControl.Left := 2;
    sImgControl.Top := (sMemo1.CaretPos.y - sMemo1.FirstLineIndex) * (abs(sMemo1.Font.Height) + 2) + 1;
    sImgControl.Width := EditWidth;
    sImgControl.Height := 16;
    sImgControl.Caption := '. . .';
    sImgControl.Parent := sPanel1;
    sImgControl.Visible := True;
    sImgControl.OnClick := EditButtonClick;
  end
  // Pattern
  else if SubInStr(ReadIniString('Main', 'Pattern', PropEditors), pname, Delim) then begin
    sImgControl := TsSpeedButton.Create(sPanel1);
    Editor := sImgControl;
    sImgControl.Tag := 1;
    sImgControl.Left := 2;
    sImgControl.Top := (sMemo1.CaretPos.y - sMemo1.FirstLineIndex) * (abs(sMemo1.Font.Height) + 2) + 1;
    sImgControl.Width := EditWidth;
    sImgControl.Height := 16;
    sImgControl.Caption := '. . .';
    sImgControl.Parent := sPanel1;
    sImgControl.Visible := True;
    sImgControl.OnClick := EditButtonClick;
  end;
end;

procedure TForm1.RealignControl;
begin
  if Editor <> nil then begin
    Editor.Top := (sMemo1.CaretPos.y - sMemo1.FirstLineIndex) * (abs(sMemo1.Font.Height) + 2) + 1;
  end;
end;

procedure TForm1.sMemo1VScroll(Sender: TObject);
begin
  RealignControl;
end;

procedure TForm1.sMemo1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if CurrentLine <> X then begin
    CreateEditor;
  end;
  CurrentLine := X;
end;

procedure TForm1.sMemo1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if CurrentLine <> sMemo1.CaretPos.y then begin
    CreateEditor;
  end;
  CurrentLine := sMemo1.CaretPos.y;
end;

procedure TForm1.PropertyChange(Sender: TObject);
begin
  inherited;
  if sCheckControl <> nil then begin
    sMemo1.Lines[sMemo1.CaretPos.y] := CurrentProp + ' = ' + sConst.Bool[integer(sCheckControl.Checked)];
    sSkinData.SkinFile.WriteString(CurrentSection, CurrentProp, sConst.Bool[integer(sCheckControl.Checked)]);
    ActionRefresh.Execute;
  end
  else if sColorControl <> nil then begin
    sMemo1.Lines[sMemo1.CaretPos.y] := CurrentProp + ' = ' + IntToStr(sColorControl.ColorValue);
    sSkinData.SkinFile.WriteString(CurrentSection, CurrentProp, IntToStr(sColorControl.ColorValue));
    ActionRefresh.Execute;
  end
  else if sPercentControl <> nil then begin
    if sPercentControl.Focused then begin
      sMemo1.Lines[sMemo1.CaretPos.y] := CurrentProp + ' = ' + IntToStr(sPercentControl.Value);
      sSkinData.SkinFile.WriteString(CurrentSection, CurrentProp, IntToStr(sPercentControl.Value));
      ActionRefresh.Execute;
    end;
  end
end;

procedure TForm1.sMemo1Change(Sender: TObject);
begin
  UpdateEditor;
  SkinChanged := True;
  ActionRefresh.Enabled := True;
end;

procedure TForm1.UpdateEditor;
begin
//
end;

procedure TForm1.EditButtonClick(Sender: TObject);
var
  s, st : string;
  ga : TsGradArray;
begin
  if sGradControl <> nil then begin
    CreateEditorForm;
    s := ExtractWord(2, sMemo1.Lines[sMemo1.CaretPos.y], Delim);
    PrepareGradArray(s, ga);
    GradBuilder.LoadFromArray(ga);
    GradBuilder.ShowModal;
    s := GradBuilder.AsString;
    sMemo1.Lines[sMemo1.CaretPos.y] := CurrentProp + ' = ' + s;
    sSkinData.SkinFile.WriteString(CurrentSection, CurrentProp, s);
    KillForm;
    ActionRefresh.Execute;
  end
  else if sImgControl <> nil then begin
    if boolean(sImgControl.Tag) then begin
      OpenPictureDialog1.Filter := 'Patterns|*.bmp;*.jpg;*.jpeg';
      OpenPictureDialog1.DefaultExt := '*.bmp;*.jpg;*.jpeg';       
    end
    else begin
      OpenPictureDialog1.Filter := 'AlphaMasks(*.bmp)|*.bmp';
      OpenPictureDialog1.DefaultExt := '*.bmp';
    end;
    OpenPictureDialog1.FileName := ExtractWord(2, sMemo1.Lines[sMemo1.CaretPos.y], Delim);

    if OpenPictureDialog1.Execute then begin
      st := ExtractFilePath(OpenPictureDialog1.FileName);
      if UpperCase(sSkinData.SkinPath) = UpperCase(NormalDir(st)) then begin
        sMemo1.Lines[sMemo1.CaretPos.y] := CurrentProp + ' = ' + ExtractFileName(OpenPictureDialog1.FileName);
      end
      else begin
        sMemo1.Lines[sMemo1.CaretPos.y] := CurrentProp + ' = ' + OpenPictureDialog1.FileName;
      end;
      sSkinData.SkinFile.WriteString(CurrentSection, CurrentProp, s);
      ActionRefresh.Execute;
    end;
  end;
end;

procedure TForm1.ActionCreateSectionExecute(Sender: TObject);
var
  s : string;
begin
  if InputQuery('String input', 'Enter name of section : ', s) then begin
    sListBox2.Items.Add(s);
  end;
end;

procedure TForm1.RemoveEditors;
begin
  FreeAndNil(sCheckControl);
  FreeAndNil(sColorControl);
  FreeAndNil(sPercentControl);
  FreeAndNil(sGradControl);
  FreeAndNil(sImgControl);
  Editor := nil;
end;

procedure TForm1.ActionExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TForm1.ActionRenameSectionExecute(Sender: TObject);
var
  s : string;
begin
  s := sListBox2.Items[sListBox2.ItemIndex];
  if InputQuery('String input', 'Enter new name of section : ', s) then begin
    sListBox2.Items[sListBox2.ItemIndex] := s;
  end;
end;

procedure TForm1.ActionPropEditExecute(Sender: TObject);
begin
  Application.CreateForm(TFormPropEdit, FormPropEdit);
  FormPropEdit.ShowModal;
end;

end.
